/**
 * ----------------------------------------------------------------------------------
 *
 * Copyright (C) 2011 runlevel3 GmbH Berlin
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE:
 *
 * This file is part of USB-AD-Interface.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ----------------------------------------------------------------------------------
 *
 * AVR Studio 4.18 / avr-gcc version 4.3.3
 *
 * ----------------------------------------------------------------------------------
 *
 * @copyright 2011 runlevel3 GmbH
 * @license   http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @link      http://www.runlevel3.de runlevel3
 **/


#ifndef config_h_
#define config_h_

//debug messages via serial interface
//#define DEBUG
//more verbose debug messages
//#define DEBUG1

#define	VERSIONSTR		"V_1.0_16.10.2011"

#define CONFIG_BASE_ADDR			0x00
#define CONFIG_BASE_ADDR_ALT		0x80
#define STAT_LOOPS_DEFAULT			32
#define STAT_LOOPS_MAX				256
#define AUTO_CONVERT_DEFAULT		0
#define AUTO_CONVERT_MODE			0x20
#define AUTO_CONVERT_INTERVAL		1000
#define STARTUP_OFFSET_DEFAULT		1


#define LED_PORT		PORTA
#define LED_DDR			DDRA
#define LED_BIT			PA1

#define	RESET_PORT		PORTA
#define	RESET_PIN		PINA
#define	RESET_BIT		PA0


typedef struct _config {
	unsigned long offset;
	unsigned long gain;
	unsigned int stat_loops;
	unsigned char auto_convert;
	unsigned char auto_mode;
	unsigned long auto_interval;
	unsigned char startup_offset;
	unsigned int crc16;
} _config;



void config_defaults(void);
unsigned int get_config(unsigned int base_address);
unsigned int read_config(void);
void write_config(void);



#endif
