/**
 * ----------------------------------------------------------------------------------
 *
 * Copyright (C) 2011 runlevel3 GmbH Berlin
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE:
 *
 * This file is part of USB-AD-Interface.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ----------------------------------------------------------------------------------
 *
 * AVR Studio 4.18 / avr-gcc version 4.3.3
 *
 * ----------------------------------------------------------------------------------
 *
 * @copyright 2011 runlevel3 GmbH
 * @license   http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @link      http://www.runlevel3.de runlevel3
 **/


#ifndef rules_h_
#define rules_h_


#ifndef DOUBLEBAUD
	#define DOUBLEBAUD 0
#endif

#define BAUD300    (F_CPU / (   4800)) * (DOUBLEBAUD + 1) - 1
#define BAUD600    (F_CPU / (   9600)) * (DOUBLEBAUD + 1) - 1
#define BAUD1200   (F_CPU / (  19200)) * (DOUBLEBAUD + 1) - 1
#define BAUD2400   (F_CPU / (  38400)) * (DOUBLEBAUD + 1) - 1
#define BAUD4800   (F_CPU / (  76800)) * (DOUBLEBAUD + 1) - 1
#define BAUD9600   (F_CPU / ( 153600)) * (DOUBLEBAUD + 1) - 1
#define BAUD14400  (F_CPU / ( 230400)) * (DOUBLEBAUD + 1) - 1
#define BAUD19200  (F_CPU / ( 307200)) * (DOUBLEBAUD + 1) - 1
#define BAUD28800  (F_CPU / ( 460800)) * (DOUBLEBAUD + 1) - 1
#define BAUD38400  (F_CPU / ( 614400)) * (DOUBLEBAUD + 1) - 1
#define BAUD57600  (F_CPU / ( 921600)) * (DOUBLEBAUD + 1) - 1
#define BAUD76800  (F_CPU / (1228800)) * (DOUBLEBAUD + 1) - 1
#define BAUD115200 (F_CPU / (1843200)) * (DOUBLEBAUD + 1) - 1
#define BAUD230400 (F_CPU / (3686400)) * (DOUBLEBAUD + 1) - 1

#define	SENDBUFFSIZE_DEFAULT	256
#define	RECVBUFFSIZE_DEFAULT	256

unsigned char USART_init(unsigned int baud, unsigned char dbaud, unsigned int _sendbuffsize, unsigned int _rcvbuffsize);
void USART_free(void);
int USART_putchar(char usart_char, FILE *stream);
int USART_getchar(FILE *stream);
unsigned int USART_inbuffused(void);
unsigned int USART_outbuffused(void);
unsigned int USART_transmit(char *usart_text);
unsigned int USART_receive(char *usart_text, unsigned int max);
unsigned int USART_inbuffsize(void);
unsigned int USART_outbuffsize(void);
unsigned int USART_inbufffree(void);
unsigned int USART_outbufffree(void);


#endif
