/**
 * ----------------------------------------------------------------------------------
 *
 * Copyright (C) 2011 runlevel3 GmbH Berlin
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE:
 *
 * This file is part of USB-AD-Interface.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ----------------------------------------------------------------------------------
 *
 * AVR Studio 4.18 / avr-gcc version 4.3.3
 *
 * ----------------------------------------------------------------------------------
 *
 * @copyright 2011 runlevel3 GmbH
 * @license   http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @link      http://www.runlevel3.de runlevel3
 **/


#ifndef usb_commands_h_
#define usb_commands_h_

#define USB_VALUE_OFFSET					4

#define USB_CMD_WRITE_COMMAND               0x08
#define USB_CMD_STARTUP_OFFSET				0x09
#define USB_CMD_OFFSET                 		0x0a
#define USB_CMD_GAIN                   		0x0b
#define USB_CMD_OFFSET_SELFCALIBRATION      0x0c
#define USB_CMD_OFFSET_SYSTEMCALIBRATION    0x0d
#define USB_CMD_GAIN_SYSTEMCALIBRATION      0x0e
#define USB_CMD_WRITE_CONFIG                0x0f
#define USB_CMD_RESET_CONFIG				0x18
#define USB_CMD_AUTO                  		0x19
#define USB_CMD_STAT_LOOPS            		0x1a
#define USB_CMD_READ_MEAN                   0x1b
#define USB_CMD_READ_VARIANCE               0x1c
#define USB_CMD_READ_STD_DEV                0x1d
#define USB_CMD_READ_MEDIAN                 0x1e
#define USB_CMD_REBOOT						0x1f


#define	USB_CMD_CONVERT_AINP_AINM			0x20
#define	USB_CMD_CONVERT_AINM_AINM			0x23
#define	USB_CMD_CONVERT_TEMP				0x26
#define	USB_CMD_CONVERT_VDD					0x27
#define	USB_CMD_CONVERT_UNI					0x40
#define	USB_CMD_CONVERT_BURNOUT				0x80

//signals for timer interrupt
#define SIGNAL_WRITE_OFFSET                0x01
#define SIGNAL_WRITE_GAIN                  0x02
#define SIGNAL_OFFSET_SELFCALIBRATION      0x04
#define SIGNAL_OFFSET_SYSTEMCALIBRATION    0x08
#define SIGNAL_GAIN_SYSTEMCALIBRATION      0x10
#define SIGNAL_READ_OFFSET                 0x20
#define SIGNAL_READ_GAIN                   0x40
#define SIGNAL_CONVERT	                   0x80


#endif
